SFML - Simple and Fast Multimedia Library

SFML 2.5.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
sf::CircleShape Class Reference
Graphics module

Specialized shape representing a circle. More...

`#include <CircleShape.hpp>`

Inheritance diagram for sf::CircleShape:

## Public Member Functions
| CircleShape (float radius=0, std::size_t pointCount=30)
| Default constructor. More...
void | setRadius (float radius)
| Set the radius of the circle. More...
float | getRadius () const
| Get the radius of the circle. More...
void | setPointCount (std::size_t count)
| Set the number of points of the circle. More...
virtual std::size_t | getPointCount () const
| Get the number of points of the circle. More...
virtual Vector2f | getPoint (std::size_t index) const
| Get a point of the circle. More...
void | setTexture (const Texture *texture, bool resetRect=false)
| Change the source texture of the shape. More...
void | setTextureRect (const IntRect &rect)
| Set the sub-rectangle of the texture that the shape will display. More...
void | setFillColor (const Color &color)
| Set the fill color of the shape. More...
void | setOutlineColor (const Color &color)
| Set the outline color of the shape. More...
void | setOutlineThickness (float thickness)
| Set the thickness of the shape's outline. More...
const Texture * | getTexture () const
| Get the source texture of the shape. More...
const IntRect & | getTextureRect () const
| Get the sub-rectangle of the texture displayed by the shape. More...
const Color & | getFillColor () const
| Get the fill color of the shape. More...
const Color & | getOutlineColor () const
| Get the outline color of the shape. More...
float | getOutlineThickness () const
| Get the outline thickness of the shape. More...
FloatRect | getLocalBounds () const
| Get the local bounding rectangle of the entity. More...
FloatRect | getGlobalBounds () const
| Get the global (non-minimal) bounding rectangle of the entity. More...
void | setPosition (float x, float y)
| set the position of the object More...
void | setPosition (const Vector2f &position)
| set the position of the object More...
void | setRotation (float angle)
| set the orientation of the object More...
void | setScale (float factorX, float factorY)
| set the scale factors of the object More...
void | setScale (const Vector2f &factors)
| set the scale factors of the object More...
void | setOrigin (float x, float y)
| set the local origin of the object More...
void | setOrigin (const Vector2f &origin)
| set the local origin of the object More...
const Vector2f & | getPosition () const
| get the position of the object More...
float | getRotation () const
| get the orientation of the object More...
const Vector2f & | getScale () const
| get the current scale of the object More...
const Vector2f & | getOrigin () const
| get the local origin of the object More...
void | move (float offsetX, float offsetY)
| Move the object by a given offset. More...
void | move (const Vector2f &offset)
| Move the object by a given offset. More...
void | rotate (float angle)
| Rotate the object. More...
void | scale (float factorX, float factorY)
| Scale the object. More...
void | scale (const Vector2f &factor)
| Scale the object. More...
const Transform & | getTransform () const
| get the combined transform of the object More...
const Transform & | getInverseTransform () const
| get the inverse of the combined transform of the object More...

## Protected Member Functions
void | update ()
| Recompute the internal geometry of the shape. More...

## Detailed Description

Specialized shape representing a circle.

This class inherits all the functions of sf::Transformable (position, rotation, scale, bounds, ...) as well as the functions of sf::Shape (outline, color, texture, ...).

Usage example:

sf::CircleShape circle;
circle.setRadius(150);
circle.setOutlineColor(sf::Color::Red);
circle.setOutlineThickness(5);
circle.setPosition(10, 20);
...
window.draw(circle);
sf::CircleShape
Specialized shape representing a circle.
Definition: CircleShape.hpp:42
sf::CircleShape::setRadius
void setRadius(float radius)
Set the radius of the circle.
sf::Color::Red
static const Color Red
Red predefined color.
Definition: Color.hpp:85
sf::Shape::setOutlineColor
void setOutlineColor(const Color &color)
Set the outline color of the shape.
sf::Shape::setOutlineThickness
void setOutlineThickness(float thickness)
Set the thickness of the shape's outline.
sf::Transformable::setPosition
void setPosition(float x, float y)
set the position of the object

Since the graphics card can't draw perfect circles, we have to fake them with multiple triangles connected to each other. The "points count" property of sf::CircleShape defines how many of these triangles to use, and therefore defines the quality of the circle.

The number of points can also be used for another purpose; with small numbers you can create any regular polygon shape: equilateral triangle, square, pentagon, hexagon, ...

See also
  sf::Shape, sf::RectangleShape, sf::ConvexShape

Definition at line 41 of file CircleShape.hpp.

## Constructor & Destructor Documentation

## ◆ CircleShape()

sf::CircleShape::CircleShape | ( | float | radius = `0`,
|  | std::size_t | pointCount = `30`
| ) |  |
| explicit

Default constructor.

Parameters

  radius | Radius of the circle
  pointCount | Number of points composing the circle

## Member Function Documentation

## ◆ getFillColor()

const Color & sf::Shape::getFillColor | ( |  | ) | const
| inherited

Get the fill color of the shape.

Returns
  Fill color of the shape

See also
  setFillColor

## ◆ getGlobalBounds()

FloatRect sf::Shape::getGlobalBounds | ( |  | ) | const
| inherited

Get the global (non-minimal) bounding rectangle of the entity.

The returned rectangle is in global coordinates, which means that it takes into account the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the shape in the global 2D world's coordinate system.

This function does not necessarily return the minimal bounding rectangle. It merely ensures that the returned rectangle covers all the vertices (but possibly more). This allows for a fast approximation of the bounds as a first check; you may want to use more precise checks on top of that.

Returns
  Global bounding rectangle of the entity

## ◆ getInverseTransform()

const Transform & sf::Transformable::getInverseTransform | ( |  | ) | const
| inherited

get the inverse of the combined transform of the object

Returns
  Inverse of the combined transformations applied to the object

See also
  getTransform

## ◆ getLocalBounds()

FloatRect sf::Shape::getLocalBounds | ( |  | ) | const
| inherited

Get the local bounding rectangle of the entity.

The returned rectangle is in local coordinates, which means that it ignores the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the entity in the entity's coordinate system.

Returns
  Local bounding rectangle of the entity

## ◆ getOrigin()

const Vector2f & sf::Transformable::getOrigin | ( |  | ) | const
| inherited

get the local origin of the object

Returns
  Current origin

See also
  setOrigin

## ◆ getOutlineColor()

const Color & sf::Shape::getOutlineColor | ( |  | ) | const
| inherited

Get the outline color of the shape.

Returns
  Outline color of the shape

See also
  setOutlineColor

## ◆ getOutlineThickness()

float sf::Shape::getOutlineThickness | ( |  | ) | const
| inherited

Get the outline thickness of the shape.

Returns
  Outline thickness of the shape

See also
  setOutlineThickness

## ◆ getPoint()

virtual Vector2f sf::CircleShape::getPoint | ( | std::size_t | index | ) | const
| virtual

Get a point of the circle.

The returned point is in local coordinates, that is, the shape's transforms (position, rotation, scale) are not taken into account. The result is undefined if index is out of the valid range.

Parameters

  index | Index of the point to get, in range [0 .. getPointCount() - 1]

Returns
  index-th point of the shape

Implements sf::Shape.

## ◆ getPointCount()

virtual std::size_t sf::CircleShape::getPointCount | ( |  | ) | const
| virtual

Get the number of points of the circle.

Returns
  Number of points of the circle

See also
  setPointCount

Implements sf::Shape.

## ◆ getPosition()

const Vector2f & sf::Transformable::getPosition | ( |  | ) | const
| inherited

get the position of the object

Returns
  Current position

See also
  setPosition

## ◆ getRadius()

float sf::CircleShape::getRadius | ( |  | ) | const

Get the radius of the circle.

Returns
  Radius of the circle

See also
  setRadius

## ◆ getRotation()

float sf::Transformable::getRotation | ( |  | ) | const
| inherited

get the orientation of the object

The rotation is always in the range [0, 360].

Returns
  Current rotation, in degrees

See also
  setRotation

## ◆ getScale()

const Vector2f & sf::Transformable::getScale | ( |  | ) | const
| inherited

get the current scale of the object

Returns
  Current scale factors

See also
  setScale

## ◆ getTexture()

const Texture * sf::Shape::getTexture | ( |  | ) | const
| inherited

Get the source texture of the shape.

If the shape has no source texture, a NULL pointer is returned. The returned pointer is const, which means that you can't modify the texture when you retrieve it with this function.

Returns
  Pointer to the shape's texture

See also
  setTexture

## ◆ getTextureRect()

const IntRect & sf::Shape::getTextureRect | ( |  | ) | const
| inherited

Get the sub-rectangle of the texture displayed by the shape.

Returns
  Texture rectangle of the shape

See also
  setTextureRect

## ◆ getTransform()

const Transform & sf::Transformable::getTransform | ( |  | ) | const
| inherited

get the combined transform of the object

Returns
  Transform combining the position/rotation/scale/origin of the object

See also
  getInverseTransform

## ◆ move() [1/2]

void sf::Transformable::move | ( | const Vector2f & | offset | ) |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

object.setPosition(object.getPosition() + offset);
sf::Transformable::getPosition
const Vector2f & getPosition() const
get the position of the object

Parameters

  offset | Offset

See also
  setPosition

## ◆ move() [2/2]

void sf::Transformable::move | ( | float | offsetX,
|  | float | offsetY
| ) |  |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f pos = object.getPosition();
object.setPosition(pos.x + offsetX, pos.y + offsetY);
sf::Vector2< float >
sf::Vector2::x
T x
X coordinate of the vector.
Definition: Vector2.hpp:75
sf::Vector2::y
T y
Y coordinate of the vector.
Definition: Vector2.hpp:76

Parameters

  offsetX | X offset
  offsetY | Y offset

See also
  setPosition

## ◆ rotate()

void sf::Transformable::rotate | ( | float | angle | ) |
| inherited

Rotate the object.

This function adds to the current rotation of the object, unlike setRotation which overwrites it. Thus, it is equivalent to the following code:

object.setRotation(object.getRotation() + angle);
sf::Transformable::getRotation
float getRotation() const
get the orientation of the object

Parameters

  angle | Angle of rotation, in degrees

## ◆ scale() [1/2]

void sf::Transformable::scale | ( | const Vector2f & | factor | ) |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factor.x, scale.y * factor.y);
sf::Transformable::scale
void scale(float factorX, float factorY)
Scale the object.

Parameters

  factor | Scale factors

See also
  setScale

## ◆ scale() [2/2]

void sf::Transformable::scale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factorX, scale.y * factorY);

Parameters

  factorX | Horizontal scale factor
  factorY | Vertical scale factor

See also
  setScale

## ◆ setFillColor()

void sf::Shape::setFillColor | ( | const Color & | color | ) |
| inherited

Set the fill color of the shape.

This color is modulated (multiplied) with the shape's texture if any. It can be used to colorize the shape, or change its global opacity. You can use sf::Color::Transparent to make the inside of the shape transparent, and have the outline alone. By default, the shape's fill color is opaque white.

Parameters

  color | New color of the shape

See also
  getFillColor, setOutlineColor

## ◆ setOrigin() [1/2]

void sf::Transformable::setOrigin | ( | const Vector2f & | origin | ) |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  origin | New origin

See also
  getOrigin

## ◆ setOrigin() [2/2]

void sf::Transformable::setOrigin | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new origin
  y | Y coordinate of the new origin

See also
  getOrigin

## ◆ setOutlineColor()

void sf::Shape::setOutlineColor | ( | const Color & | color | ) |
| inherited

Set the outline color of the shape.

By default, the shape's outline color is opaque white.

Parameters

  color | New outline color of the shape

See also
  getOutlineColor, setFillColor

## ◆ setOutlineThickness()

void sf::Shape::setOutlineThickness | ( | float | thickness | ) |
| inherited

Set the thickness of the shape's outline.

Note that negative values are allowed (so that the outline expands towards the center of the shape), and using zero disables the outline. By default, the outline thickness is 0.

Parameters

  thickness | New outline thickness

See also
  getOutlineThickness

## ◆ setPointCount()

void sf::CircleShape::setPointCount | ( | std::size_t | count | ) |

Set the number of points of the circle.

Parameters

  count | New number of points of the circle

See also
  getPointCount

## ◆ setPosition() [1/2]

void sf::Transformable::setPosition | ( | const Vector2f & | position | ) |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  position | New position

See also
  move, getPosition

## ◆ setPosition() [2/2]

void sf::Transformable::setPosition | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new position
  y | Y coordinate of the new position

See also
  move, getPosition

## ◆ setRadius()

void sf::CircleShape::setRadius | ( | float | radius | ) |

Set the radius of the circle.

Parameters

  radius | New radius of the circle

See also
  getRadius

## ◆ setRotation()

void sf::Transformable::setRotation | ( | float | angle | ) |
| inherited

set the orientation of the object

This function completely overwrites the previous rotation. See the rotate function to add an angle based on the previous rotation instead. The default rotation of a transformable object is 0.

Parameters

  angle | New rotation, in degrees

See also
  rotate, getRotation

## ◆ setScale() [1/2]

void sf::Transformable::setScale | ( | const Vector2f & | factors | ) |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factors | New scale factors

See also
  scale, getScale

## ◆ setScale() [2/2]

void sf::Transformable::setScale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factorX | New horizontal scale factor
  factorY | New vertical scale factor

See also
  scale, getScale

## ◆ setTexture()

void sf::Shape::setTexture | ( | const Texture * | texture,
|  | bool | resetRect = `false`
| ) |  |
| inherited

Change the source texture of the shape.

The texture argument refers to a texture that must exist as long as the shape uses it. Indeed, the shape doesn't store its own copy of the texture, but rather keeps a pointer to the one that you passed to this function. If the source texture is destroyed and the shape tries to use it, the behavior is undefined. texture can be NULL to disable texturing. If resetRect is true, the TextureRect property of the shape is automatically adjusted to the size of the new texture. If it is false, the texture rect is left unchanged.

Parameters

  texture | New texture
  resetRect | Should the texture rect be reset to the size of the new texture?

See also
  getTexture, setTextureRect

## ◆ setTextureRect()

void sf::Shape::setTextureRect | ( | const IntRect & | rect | ) |
| inherited

Set the sub-rectangle of the texture that the shape will display.

The texture rect is useful when you don't want to display the whole texture, but rather a part of it. By default, the texture rect covers the entire texture.

Parameters

  rect | Rectangle defining the region of the texture to display

See also
  getTextureRect, setTexture

## ◆ update()

void sf::Shape::update | ( |  | ) |
| protectedinherited

Recompute the internal geometry of the shape.

This function must be called by the derived class everytime the shape's points change (i.e. the result of either getPointCount or getPoint is different).

The documentation for this class was generated from the following file:

- CircleShape.hpp